## chuffed 0.13.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)

project(chuffed CXX C)
# The version number.
set(chuffed_VERSION_MAJOR 0)
set(chuffed_VERSION_MINOR 13)
set(chuffed_VERSION_PATCH 1)

### Additional Definitions:
option(STATIC "compile with the -static linker flag" OFF)
option(CP_PROFILER "Build with the CP Profiler Integration" ON)
option(SUPPORT_VAR_IMPACT "Build with support for impact branching" OFF)
# ------------- Compiler Configuration -------------

if(STATIC)
  set(CMAKE_EXE_LINKER_FLAGS "-static")
endif()

set(DEFAULT_BUILD_TYPE "Release")
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to '${DEFAULT_BUILD_TYPE}' as none was specified.")
  set(CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}" CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
    "Debug"
    "Release"
    "MinSizeRel"
    "RelWithDebInfo"
  )
endif()

if(APPLE)
  execute_process(COMMAND xcrun --show-sdk-path OUTPUT_VARIABLE OSX_SYSROOT OUTPUT_STRIP_TRAILING_WHITESPACE)
  set(CMAKE_OSX_SYSROOT ${OSX_SYSROOT})
  set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")
endif(APPLE)

set(CMAKE_CXX_STANDARD 11)

find_package(Threads)

include_directories(${CMAKE_BINARY_DIR})
include_directories(${CMAKE_SOURCE_DIR})
if(WIN32)
  add_definitions(-DYY_NO_UNISTD_H)
endif()

# ------------- CP Profiler Integration -------------

add_library(thirdparty_cp_profiler OBJECT
  thirdparty/cp-profiler-integration/connector.hpp
  thirdparty/cp-profiler-integration/message.hpp
)
set_target_properties(thirdparty_cp_profiler PROPERTIES LINKER_LANGUAGE CXX)
set_target_properties(thirdparty_cp_profiler PROPERTIES
  CXX_CLANG_TIDY ""
)

# ---------- Support for impact branching -----------

if(SUPPORT_VAR_IMPACT)
  add_definitions(-DHAS_VAR_IMPACT)
  set(VAR_IMPACT_SOURCES
    chuffed/branching/impact.cpp
  )
endif()

# ------------- Murmur Hash 3 -------------

add_library(thirdparty_murmur OBJECT
  thirdparty/MurmurHash3/MurmurHash3.cpp
  thirdparty/MurmurHash3/MurmurHash3.h
)
set_target_properties(thirdparty_murmur PROPERTIES
  CXX_CLANG_TIDY ""
)

# ------------- Main Chuffed Definition -------------

add_library(chuffed
  chuffed/vars/int-var.cpp
  chuffed/vars/int-var-el.cpp
  chuffed/vars/modelling.cpp
  chuffed/vars/int-var-sl.cpp
  chuffed/vars/bool-view.cpp
  chuffed/vars/int-var-ll.cpp
  chuffed/ldsb/ldsb.cpp
  chuffed/globals/subcircuit.cpp
  chuffed/globals/mddglobals.cpp
  chuffed/globals/sym-break.cpp
  chuffed/globals/linear-bool.cpp
  chuffed/globals/linear-bool-decomp.cpp
  chuffed/globals/well-founded.cpp
  chuffed/globals/circuit.cpp
  chuffed/globals/minimum.cpp
  chuffed/globals/bool_arg_max.cpp
  chuffed/globals/alldiff.cpp
  chuffed/globals/template.cpp
  chuffed/globals/directives.cpp
  chuffed/globals/cumulative.cpp
  chuffed/globals/cumulativeCalendar.cpp
  chuffed/globals/disjunctive.cpp
  chuffed/globals/regular.cpp
  chuffed/globals/lex.cpp
  chuffed/globals/table.cpp
  chuffed/globals/edit_distance.cpp
  chuffed/globals/EdExplFinder.cpp
  chuffed/globals/EdExplFinder.h
  chuffed/globals/value-precede.cpp
  chuffed/globals/graph.cpp
  chuffed/globals/tree.cpp
  chuffed/globals/minimum_weight_tree.cpp
  chuffed/globals/mst.cpp
  chuffed/globals/dconnected.cpp
  chuffed/globals/dtree.cpp
  chuffed/globals/dag.cpp
  chuffed/globals/bounded_path.cpp
  chuffed/mdd/MDD.cpp
  chuffed/mdd/mdd_prop.cpp
  chuffed/mdd/mdd_to_lgraph.cpp
  chuffed/mdd/opcache.cpp
  chuffed/mdd/weighted_dfa.cpp
  chuffed/mdd/wmdd_prop.cpp
  chuffed/mip/mip.cpp
  chuffed/mip/recalc.cpp
  chuffed/mip/simplex.cpp
  chuffed/primitives/element.cpp
  chuffed/primitives/bool.cpp
  chuffed/primitives/linear.cpp
  chuffed/primitives/arithmetic.cpp
  chuffed/primitives/domain.cpp
  chuffed/primitives/binary.cpp
  chuffed/branching/branching.cpp
  chuffed/core/init.cpp
  chuffed/core/stats.cpp
  chuffed/core/engine.cpp
  chuffed/core/options.cpp
  chuffed/core/sat.cpp
  chuffed/core/conflict.cpp
  chuffed/vars/int-var.h
  chuffed/vars/vars.h
  chuffed/vars/int-var-sl.h
  chuffed/vars/int-var-ll.h
  chuffed/vars/int-view.h
  chuffed/vars/int-var-el.h
  chuffed/vars/modelling.h
  chuffed/vars/bool-view.h
  chuffed/support/BVec.h
  chuffed/support/ParseUtils.h
  chuffed/support/vec.h
  chuffed/support/misc.h
  chuffed/support/heap.h
  chuffed/support/sparse_set.h
  chuffed/support/union_find.h
  chuffed/support/union_find.cpp
  chuffed/support/trailed_cst_list.h
  chuffed/support/lengauer_tarjan.h
  chuffed/support/lengauer_tarjan.cpp
  chuffed/support/dijkstra.h
  chuffed/support/dijkstra.cpp
  chuffed/support/kosaraju_scc.h
  chuffed/support/kosaraju_scc.cpp
  chuffed/support/dynamic_kmeans.h
  chuffed/support/floyd_warshall.h
  chuffed/support/set_finder.h
  chuffed/ldsb/ldsb.h
  chuffed/globals/globals.h
  chuffed/globals/mddglobals.h
  chuffed/mdd/CFG.h
  chuffed/mdd/circ_fns.h
  chuffed/mdd/circutil.h
  chuffed/mdd/CYK.h
  chuffed/mdd/MDD.h
  chuffed/mdd/mdd_prop.h
  chuffed/mdd/mdd_to_lgraph.h
  chuffed/mdd/opcache.h
  chuffed/mdd/opts.h
  chuffed/mdd/sorters.h
  chuffed/mdd/weighted_dfa.h
  chuffed/mdd/wmdd_prop.h
  chuffed/mip/mip.h
  chuffed/mip/simplex.h
  chuffed/primitives/primitives.h
  chuffed/branching/branching.h
  chuffed/core/sat.h
  chuffed/core/engine.h
  chuffed/core/sat-types.h
  chuffed/core/options.h
  chuffed/core/propagator.h
  ${VAR_IMPACT_SOURCES}

  $<TARGET_OBJECTS:thirdparty_cp_profiler>
  $<TARGET_OBJECTS:thirdparty_murmur>
)

if(CP_PROFILER)
  target_compile_definitions(chuffed PRIVATE HAS_PROFILER)
endif()

# ------------- FZN Chuffed -------------

find_package(BISON 3.4)
if(BISON_FOUND)
  file(MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/chuffed/flatzinc/generated_parser)
  bison_target(FZNParser
    ${PROJECT_SOURCE_DIR}/chuffed/flatzinc/parser.yxx
    ${PROJECT_BINARY_DIR}/parser.tab.cpp
    DEFINES_FILE ${PROJECT_BINARY_DIR}/chuffed/flatzinc/generated_parser/parser.tab.h
    COMPILE_FLAGS "-l"
  )
else()
  message(WARNING "Bison cannot be run. Using cached file, which may be out of date.")
  set(BISON_FZNParser_OUTPUTS
    ${PROJECT_SOURCE_DIR}/chuffed/flatzinc/generated_parser/parser.tab.cpp
    ${PROJECT_SOURCE_DIR}/chuffed/flatzinc/generated_parser/parser.tab.h
  )
endif()

find_package(FLEX)
if(FLEX_FOUND AND BISON_FOUND)
  flex_target(FZNLexer
    ${PROJECT_SOURCE_DIR}/chuffed/flatzinc/lexer.lxx
    ${PROJECT_BINARY_DIR}/lexer.yy.cpp
    COMPILE_FLAGS "-L"
  )
  add_flex_bison_dependency(FZNLexer FZNParser)
else()
  message(WARNING "Flex cannot be run. Using cached file, which may be out of date.")
  set(FLEX_FZNLexer_OUTPUTS ${PROJECT_SOURCE_DIR}/chuffed/flatzinc/generated_parser/lexer.yy.cpp)
endif()

# If CMAKE_UNITY_BUILD is enabled, we still want these files to be built separately
# to avoid compilation errors.
set_source_files_properties(
    ${BISON_FZNParser_OUTPUTS}
    ${FLEX_FZNLexer_OUTPUTS}
  PROPERTIES
    SKIP_UNITY_BUILD_INCLUSION ON
)

add_library(flatzinc_parser OBJECT
  ${FLEX_FZNLexer_OUTPUTS}
  ${BISON_FZNParser_OUTPUTS}
)
set_target_properties(flatzinc_parser PROPERTIES
  CXX_CLANG_TIDY ""
)

add_library(chuffed_fzn
  chuffed/flatzinc/registry.cpp
  chuffed/flatzinc/flatzinc.cpp
  chuffed/flatzinc/flatzinc.h
  chuffed/flatzinc/ast.h

  $<TARGET_OBJECTS:flatzinc_parser>
)

add_executable(fzn-chuffed chuffed/flatzinc/fzn-chuffed.cpp)
target_link_libraries(fzn-chuffed chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

# ------------- Chuffed Examples -------------

add_executable(bibd EXCLUDE_FROM_ALL chuffed/examples/bibd.cpp)
target_link_libraries(bibd chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(blackhole EXCLUDE_FROM_ALL chuffed/examples/blackhole.cpp)
target_link_libraries(blackhole chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(concert_hall EXCLUDE_FROM_ALL chuffed/examples/concert_hall.cpp)
target_link_libraries(concert_hall chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(concert_hall_sym EXCLUDE_FROM_ALL chuffed/examples/concert_hall_sym.cpp)
target_link_libraries(concert_hall_sym chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(golomb EXCLUDE_FROM_ALL chuffed/examples/golomb.cpp)
target_link_libraries(golomb chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(graceful_graph EXCLUDE_FROM_ALL chuffed/examples/graceful_graph.cpp)
target_link_libraries(graceful_graph chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(graph_colouring EXCLUDE_FROM_ALL chuffed/examples/graph_colouring.cpp)
target_link_libraries(graph_colouring chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(graph_colouring_sym EXCLUDE_FROM_ALL chuffed/examples/graph_colouring_sym.cpp)
target_link_libraries(graph_colouring_sym chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(graph_colouring_sym2 EXCLUDE_FROM_ALL chuffed/examples/graph_colouring_sym2.cpp)
target_link_libraries(graph_colouring_sym2 chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(grid_colouring EXCLUDE_FROM_ALL chuffed/examples/grid_colouring.cpp)
target_link_libraries(grid_colouring chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(latin_square EXCLUDE_FROM_ALL chuffed/examples/latin_square.cpp)
target_link_libraries(latin_square chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(magic_square EXCLUDE_FROM_ALL chuffed/examples/magic_square.cpp)
target_link_libraries(magic_square chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(mosp EXCLUDE_FROM_ALL chuffed/examples/mosp.cpp)
target_link_libraries(mosp chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(nn_queens EXCLUDE_FROM_ALL chuffed/examples/nn_queens.cpp)
target_link_libraries(nn_queens chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(non EXCLUDE_FROM_ALL chuffed/examples/non.cpp)
target_link_libraries(non chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(photo EXCLUDE_FROM_ALL chuffed/examples/photo.cpp)
target_link_libraries(photo chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(queens EXCLUDE_FROM_ALL chuffed/examples/queens.cpp)
target_link_libraries(queens chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(rcpsp EXCLUDE_FROM_ALL chuffed/examples/rcpsp.cpp)
target_link_libraries(rcpsp chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(shift EXCLUDE_FROM_ALL chuffed/examples/shift.cpp)
target_link_libraries(shift chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(steel_mill EXCLUDE_FROM_ALL chuffed/examples/steel_mill.cpp)
target_link_libraries(steel_mill chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

add_executable(wreg_shift EXCLUDE_FROM_ALL chuffed/examples/wreg_shift.cpp)
target_link_libraries(wreg_shift chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT})

find_package(ZLIB)
if(ZLIB_FOUND)
  include_directories(${ZLIB_INCLUDE_DIRS})

  add_executable(cross EXCLUDE_FROM_ALL chuffed/examples/cross.cpp)
  target_link_libraries(cross chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT} ${ZLIB_LIBRARIES})

  add_executable(fdpent EXCLUDE_FROM_ALL chuffed/examples/fdpent.cpp)
  target_link_libraries(fdpent chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT} ${ZLIB_LIBRARIES})

  add_executable(nurse EXCLUDE_FROM_ALL chuffed/examples/nurse.cpp)
  target_link_libraries(nurse chuffed_fzn chuffed ${CMAKE_THREAD_LIBS_INIT} ${ZLIB_LIBRARIES})

  set(ZLIB_EXAMPLES
    cross
    fdpent
    nurse
  )
endif()

add_custom_target(examples)
add_dependencies(examples
  bibd
  blackhole
  concert_hall
  concert_hall_sym
  golomb
  graceful_graph
  graph_colouring
  graph_colouring_sym
  graph_colouring_sym2
  grid_colouring
  latin_square
  magic_square
  mosp
  nn_queens
  non
  photo
  queens
  rcpsp
  shift
  steel_mill
  wreg_shift
  ${ZLIB_EXAMPLES}
)

# ------------- TARGET install -------------
include(GNUInstallDirs)

=== DESCRIPTION ===
Chuffed - A lazy clause solver

Geoffrey Chu, Peter J. Stuckey, Andreas Schutt, Thorsten Ehlers, Graeme Gange, Kathryn Francis

Data61, CSIRO, Australia

Department of Computing and Information Systems
University of Melbourne, Australia


Chuffed is a state of the art lazy clause solver designed from the ground up
with lazy clause generation in mind. Lazy clause generation is a hybrid
approach to constraint solving that combines features of finite domain
propagation and Boolean satisfiability. Finite domain propagation is
instrumented to record the reasons for each propagation step. This creates an
implication graph like that built by a SAT solver, which may be used to create
efficient nogoods that record the reasons for failure. These nogoods can be
propagated efficiently using SAT unit propagation technology. The resulting
hybrid system combines some of the advantages of finite domain constraint
programming (high level model and programmable search) with some of the
advantages of SAT solvers (reduced search by nogood creation, and effective
autonomous search using variable activities).

The FD components of Chuffed are very tightly integrated with a SAT solver. For
"small" variables (|D| <= 1000), SAT variables representing [x = v] or [x >= v]
are eagerly created at the start of the problem. Channelling constraints are
natively enforced by the variable objects in order to keep the FD solver and
the SAT solver's view of the domains fully consistent at all times. For "large"
variables (|D| > 1000), the SAT variables are lazily generated as needed. Every
propagator in Chuffed has been instrumented so that all propagation can be
explained by some combination of the literals in the SAT solver. An explanation
is of the form a_1 /\ ... /\ a_n -> d, where a_i represent domain restrictions
which are currently true, and d represents the domain change that is implied.
e.g. Suppose z >= x + y, and we have x >= 3, y >= 2. Then the propagator would
propagate x >= 5 with explanation clause x >= 3 /\ y >= 2 -> z >= 5.

The explanations for each propagation form an implication graph. This allows us
to do three very important things. Firstly, we can derive a nogood to explain
each failure. Such nogoods often allow us to avoid a very large amount of
redundant work, thus producing search trees which are orders of magnitude
smaller. Secondly, nogoods allow us to make informed choices about
non-chronological back-jumping. When no literal from a decision level appears
in the nogood, it is indicative of the fact that the decision made at that
level was completely irrelevant to the search. Thus by back-jumping over such
decisions, we retrospectively avoid making such bad decisions, and hopefully
make good decisions instead which drive the search towards failure. Thirdly, by
analysing the conflict, we can actively gain some information about what good
decision choices are. The Variable State Independent Decaying Sum (VSIDS)
heuristic is an extremely effective search heuristic for SAT problems, and is
also extremely good for a range of CP problems. Each variables has an
associated activity, which is increased whenever the variable is involved in
the conflict. Variables with the highest activity is chosen as the decision
variable at each node. The activities are decayed to reflect the fact that the
set of important variables changes with time.

Although Chuffed implements lazy clause generation, which is cutting edge and
rather complex, the FD parts of Chuffed are relatively simple. In fact, it is
quite minimalistic. Chuffed only supports 3 different propagator priorities.
Chuffed implements a number of global propagators (alldiff, inverse,
minimum, table, regular, mdd, cumulative, disjunctive, circuit, difference). 
It also only supports two kinds of integer variables. Small integer variables 
for which the domain is represented by a byte string.
And large integer variables for which the domain is represented only by its
upper and lower bound (no holes allowed). All boolean variables and boolean
constraints are handled by the builtin SAT solver.

Great pains have been taken to make everything as simple and efficient as
possible. The solver, when run with lazy clause generation disabled, is
somewhat comparable in speed with older versions of Gecode. The overhead from
lazy clause generation ranges from negligible to perhaps around 100%. The
search reduction, however, can reach orders of magnitude on appropriate
problems. Thus lazy clause generation is an extremely important and useful
technology. The theory behind lazy clause generation is described in much
greater detail in various papers.

=== flatzinc/Makefile ===
MZN2FZN = mzn2fzn -G ../../../../../lazy-clause/flatzinc/mznlib
MZNBENCHDIR = ~/g12/g12/zinc/benchmarks/minizinc

STILL_LIFE = 7x7 8x8 9x9
STILL_LIFE_FZN = $(STILL_LIFE:%=still_life/%.fzn)

NONOGRAM = #non_awful_1 non_awful_2 non_awful_3 non_awful_4 non_awful_5 non_med_1 non_med_2 non_med_3 non_med_4
NONOGRAM_FZN = $(NONOGRAM:%=nonogram/%.fzn)

RECTPACKING = rpp19_false rpp20_true rpp21_false rpp22_true rpp24_false rpp26_true rpp30_false
RECTPACKING_FZN = $(RECTPACKING:%=rectangle-packing/data_square/%.fzn)

GOLFERS = golfers_5_3_6 golfers_5_5_6 golfers_6_6_3
GOLFERS_FZN = $(GOLFERS:%=golfers/%.fzn)

PENTOMINOES = 01 02 03 04 05 06 07
PENTOMINOES_FZN = $(PENTOMINOES:%=pentominoes/%.fzn)

RADIATION = 01 02 03 04 05 06 07 08 09
RADIATION_FZN = $(RADIATION:%=radiation/%.fzn)

RCPSP = 00 01 02 03 04 05 06 07 08 09
RCPSP_FZN = $(RCPSP:%=rcpsp/%.fzn)

SHORTPATH = 00 01 02 03 04 05 06 07 08 09
SHORTPATH_FZN = $(SHORTPATH:%=shortest_path/%.fzn)

TEMPLATEDES = catfood_3
TEMPLATEDES_FZN = $(TEMPLATEDES:%=template_design/%.fzn)

SLOWCONVERGE = 0500 0600 0700 0800 0900
SLOWCONVERGE_FZN = $(SLOWCONVERGE:%=slow_convergence/%.fzn)

CURRICULUM = curriculum_8 curriculum_10 curriculum_12
CURRICULUM_FZN = $(CURRICULUM:%=curriculum/%.fzn)

QCP = qcp-25-264-0_ext qcp-25-264-1_ext qcp-25-264-2_ext qcp-25-264-3_ext qcp-25-264-4_ext qcp-25-264-5_ext qcp-25-264-6_ext qcp-25-264-7_ext qcp-25-264-8_ext qcp-25-264-9_ext qcp-25-264-10_ext qcp-25-264-11_ext qcp-25-264-12_ext qcp-25-264-13_ext qcp-25-264-14_ext
QCP_FZN = $(QCP:%=QCP/%.fzn)

BLACKHOLE = 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19
BLACKHOLE_FZN = $(BLACKHOLE:%=black-hole/%.fzn)

FILLOMINO = 01 07 08 11 12 13 14 15 16 17 18 19 20 21 22
FILLOMINO_FZN = $(FILLOMINO:%=fillomino/%.fzn)

P1F = 2 3 4 5 6 7 8 9 10 11 12
P1F_FZN = $(P1F:%=p1f/%.fzn)

ROSTER = chicroster_dataset_1 chicroster_dataset_2 chicroster_dataset_3 chicroster_dataset_4 chicroster_dataset_5 chicroster_dataset_6 chicroster_dataset_7 chicroster_dataset_8 chicroster_dataset_9 chicroster_dataset_10 chicroster_dataset_11 chicroster_dataset_12 chicroster_dataset_14 chicroster_dataset_17 chicroster_dataset_large_13 chicroster_dataset_large_15 chicroster_dataset_large_16 chicroster_dataset_large_18 chicroster_dataset_large_19
ROSTER_FZN = $(ROSTER:%=roster/%.fzn)

DEBRUIJN = 02_03 02_07 02_08 02_09 02_10 03_06 03_07 04_06
DEBRUIJN_FZN = $(DEBRUIJN:%=debruijn_binary/%.fzn)

TRUCKING = 01 02 03 04 05 06
TRUCKING_FZN = $(TRUCKING:%=trucking/%.fzn)

NMSEQ = 020 040 060 080 100 150 200
NMSEQ_FZN = $(NMSEQ:%=nmseq/%.fzn)

QUASIGROUP = 05 06 07 08 09
QUASIGROUP_FZN = $(QUASIGROUP:%=quasigroup7/%.fzn)

TALENT = film103 film105 film114 film116 film118 film119 MobStory
TALENT_FZN = $(TALENT:%=talent_scheduling/medium/%.fzn)

OPENSTACKS = gp50by50_1 problem_15_15_1 wbo_15_30_1 problem_20_20_1 problem_30_15_1 wbop_30_15_1
OPENSTACKS_FZN = $(OPENSTACKS:%=open_stacks/%.fzn)

NSP = 20 40 60 80 100
NSP_FZN = $(NSP:%=nsp/data/period_14/%.fzn) $(NSP:%=nsp/data/period_28/%.fzn)

ALL_FZN = $(STILL_LIFE_FZN) $(NONOGRAM_FZN) $(RECTPACKING_FZN) $(GOLFERS_FZN) \
	$(PENTOMINOES_FZN) $(RADIATION_FZN) $(RCPSP_FZN) $(SHORTPATH_FZN) \
	$(TEMPLATEDES_FZN) $(SLOWCONVERGE_FZN) $(CURRICULUM_FZN) $(QCP_FZN) \
	$(BLACKHOLE_FZN) $(FILLOMINO_FZN) $(P1F_FZN) $(ROSTER_FZN) $(DEBRUIJN_FZN) \
	$(TRUCKING_FZN) $(NMSEQ_FZN) $(QUASIGROUP_FZN) $(TALENT_FZN) $(OPENSTACKS_FZN) \
	$(NSP_FZN)


all : $(ALL_FZN)

$(STILL_LIFE_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/still_life/still_life.mzn
	$(MZN2FZN) -o $@ $^

$(NONOGRAM_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/nonogram/non.mzn
	$(MZN2FZN) -o $@ $^

$(RECTPACKING_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/rectangle-packing/rect_packing.mzn
	$(MZN2FZN) -o $@ $^

$(GOLFERS_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/golfers/golfers1.mzn
	$(MZN2FZN) -o $@ $^

$(PENTOMINOES_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/pentominoes/pentominoes-int.mzn
	$(MZN2FZN) -o $@ $^

$(RADIATION_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/radiation/radiation.mzn
	$(MZN2FZN) -o $@ $^

$(RCPSP_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/rcpsp/rcpsp.mzn
	$(MZN2FZN) -o $@ $^

$(SHORTPATH_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/shortest_path/shortest_path.mzn
	$(MZN2FZN) -o $@ $^

$(TEMPLATEDES_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/template_design/template_design.mzn
	$(MZN2FZN) -o $@ $^

$(SLOWCONVERGE_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/slow_convergence/slow_convergence.mzn
	$(MZN2FZN) -o $@ $^

$(CURRICULUM_FZN) : %.fzn : $(MZNBENCHDIR)/%.mzn
	$(MZN2FZN) -o $@ -I $(MZNBENCHDIR)/curriculum $^

$(QCP_FZN) : %.fzn : $(MZNBENCHDIR)/%.mzn
	$(MZN2FZN) -o $@ $^

$(BLACKHOLE_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/black-hole/black-hole.mzn
	$(MZN2FZN) -o $@ $^

$(FILLOMINO_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/fillomino/fillomino.mzn
	$(MZN2FZN) -o $@ $^

$(P1F_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/p1f/p1f.mzn
	$(MZN2FZN) -o $@ $^

$(ROSTER_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/roster/roster_model.mzn
	$(MZN2FZN) -o $@ $^

$(DEBRUIJN_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/debruijn_binary/debruijn_binary.mzn
	$(MZN2FZN) -o $@ $^

$(TRUCKING_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/trucking/trucking_no_colgen.mzn
	$(MZN2FZN) -o $@ $^

$(NMSEQ_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/nmseq/nmseq.mzn
	$(MZN2FZN) -o $@ $^

$(QUASIGROUP_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/quasigroup7/quasigroup7.mzn
	$(MZN2FZN) -o $@ $^

$(TALENT_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/talent_scheduling/talent_scheduling_alt.mzn
	$(MZN2FZN) -o $@ $^

$(OPENSTACKS_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/open_stacks/open_stacks_01.mzn
	$(MZN2FZN) -o $@ $^

$(NSP_FZN) : %.fzn : $(MZNBENCHDIR)/%.dzn $(MZNBENCHDIR)/nsp/nsp_1.mzn
	$(MZN2FZN) -o $@ -I $(MZNBENCHDIR)/nsp $^








clean :
	rm -rf $(ALL_FZN)

=== debian/changelog ===
chuffed (0.13.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1063388)
  * Use libmurmurhash instead of included implementation

 -- Kari Pahula <kaol@debian.org>  Sat, 10 Feb 2024 14:02:14 +0200

=== debian/control ===
Source: chuffed
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Kari Pahula <kaol@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 bison,
 flex,
 zlib1g-dev,
 libmurmurhash-dev,
 pkgconf,
Standards-Version: 4.6.2
Homepage: https://github.com/chuffed/chuffed
Vcs-Browser: https://salsa.debian.org/science-team/chuffed
Vcs-Git: https://salsa.debian.org/science-team/chuffed.git

Package: chuffed-flatzinc
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Recommends:
 minizinc,
Description: lazy clause generation FlatZinc implememntation
 Chuffed is a state of the art lazy clause solver designed from the
 ground up with lazy clause generation in mind. Lazy clause generation
 is a hybrid approach to constraint solving that combines features of
 finite domain propagation and Boolean satisfiability. It combines
 some of the advantages of finite domain constraint programming (high
 level model and programmable search) with some of the advantages of
 SAT solvers (reduced search by nogood creation, and effective
 autonomous search using variable activities).
 .
 Chuffed only supports 3 different propagator priorities. Chuffed
 implements a number of global propagators (alldiff, inverse, minimum,
 table, regular, mdd, cumulative, disjunctive, circuit,
 difference). It also only supports two kinds of integer
 variables. Small integer variables for which the domain is
 represented by a byte string. And large integer variables for which
 the domain is represented only by its upper and lower bound (no holes
 allowed). All boolean variables and boolean constraints are handled
 by the builtin SAT solver.
 .
 The solver, when run with lazy clause generation disabled, is
 somewhat comparable in speed with older versions of Gecode. The
 overhead from lazy clause generation ranges from negligible to
 perhaps around 100%. The search reduction, however, can reach orders
 of magnitude on appropriate problems. Thus lazy clause generation is
 an extremely important and useful technology.
 .
 This package provides a FlatZinc implementation, to be used as a
 MiniZinc backend.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

# Upstream doesn't recommend using Chuffed as a library.  See
# https://github.com/chuffed/chuffed/pull/182
execute_after_dh_install:
	rm -r debian/chuffed-flatzinc/usr/lib debian/chuffed-flatzinc/usr/include

=== debian/watch ===
# Compulsory line, this is a version 4 file.
version=4

# Direct Git.
opts="mode=git" https://github.com/chuffed/chuffed.git \
    refs/tags/([\d\.]+)

# Upstream has been doing releases with tags only, ignore Github's
# release pages.
